package solutions.reslate.entertainment.spigotresourcesync.synchronisation;

import java.io.File;
import java.io.IOException;
import java.nio.file.Path;

import org.apache.commons.io.FileUtils;

public class ApacheCommonsIOSynchroniser implements Synchroniser {

    @Override
    public void sync(File source, File dest, File root) throws IOException {
        if (root != null) {
            source = Path.of(root.getPath(), source.getPath()).toFile();
            source = Path.of(root.getPath(), dest.getPath()).toFile();
        }

        if (source.isDirectory()) {
            if (dest.isDirectory()) {
                FileUtils.copyDirectory(source, dest);
            } else {
                throw new IOException("Cannot synchronise directory to non-directory!");
                // TODO add more detail to error message.
            }
        } else {
            if (dest.isDirectory()) {
                FileUtils.copyFileToDirectory(source, dest);
            } else {
                FileUtils.copyFile(source, dest);
            }
        }
    }

    @Override
    public void sync(String source, String dest, String root) throws IOException {
        this.sync(new File(source), new File(dest), root != null ? new File(root) : null);
    }

	@Override
	public void sync(File source, File dest) throws IOException {
        sync(source, dest, null);
	}

	@Override
	public void sync(String source, String dest) throws IOException {
        sync(source, dest, null);
	}
    
}
